#!/usr/bin/env python

import matplotlib.pyplot as plt
import numpy as np

fig, ax = plt.subplots()

N = 6

localsort = [1.927, 1.858, 1.807, 1.943, 1.854, 1.813]
chist = [8.271, 8.246, 8.219, 8.24, 8.325, 8.285]
cdata_exchange = [16.683, 16.586, 16.555, 16.631, 16.652, 16.663]
hist = [a_i - b_i for a_i, b_i in zip(chist, localsort)]
data_exchange = [a_i - b_i for a_i, b_i in zip(cdata_exchange, chist)]

ind = np.arange(N)    # the x locations for the groups
width = 0.30       # the width of the bars: can also be len(x) sequence


colors = ['#0e326d', '#028413', 'grey']
edgecolors = ['#000000', '#444444']


#edgecolors = ['#a84d05', '#444444']

#color1 = '#e06c0d' #(1.0,0.5,0.62)
#color2 = '#af0505' #'#028413' #(0.2588,0.4433,1.0)
#color3 = '#999999' #'#d62728'


p1 = plt.bar(ind, localsort, width, hatch="//",
		 color=colors[0],align='center', linewidth = 1, edgecolor = edgecolors[0])
p2 = plt.bar(ind, hist, width, bottom=localsort,
		 color=colors[1], align='center', linewidth = 1)
p3 = plt.bar(ind, data_exchange, width, bottom=chist, hatch="\\\\",
		 color=colors[2], align='center', linewidth = 1, edgecolor = edgecolors[1])

pcolor = '#0e326d'

#plt.plot(ind, cdata_exchange, '-', color=pcolor,  lw=3.0,  
#	marker='x', mew = 3.0, markersize = 10,
#	markerfacecolor='none', markeredgecolor=pcolor,
#	dash_capstyle='round', label='HSS')


label_fontsize=15
plt.ylabel('Execution time (sec)', fontsize=label_fontsize)
#plt.xlabel('Distribution')
#plt.title('HSS: weak scaling')
plt.xticks(ind, ("UNIF", "SKEW1", "SKEW2", "SKEW3", "GAUSS", "AllZeros"))
#plt.yticks(np.arange(0, 81, 10))
plt.ylim(ymin=0, ymax=24)
leg = plt.legend((p3[0], p2[0], p1[0]), ('data exchange', 'histogramming','local sort'), fontsize=label_fontsize)
#leg = plt.legend(bbox_to_anchor=(0.06, 0.9), borderaxespad=0, loc=2, numpoints=3, handlelength=5,prop={'size':12})
leg.get_frame().set_linewidth(0.0)
ax.set_axisbelow(True)
ax.yaxis.grid()
plt.xticks(rotation=45)
plt.savefig("diff_dist.pdf")
#plt.show()

'''
import numpy as np
import pylab as P
import matplotlib.pyplot as plt
import matplotlib
from matplotlib.ticker import LogLocator

fig, ax = plt.subplots()

#
# The hist() function now has a lot more options
#
#mu, sigma = 200, 25
#x = sigma*P.randn(4,3)


#print x[0], x[1], x[2], x[3], len(x)
counts, bins, patches = plt.hist(x, 4, histtype='bar', stacked=True)
plt.grid(linestyle=':', linewidth=1, color='grey')
#P.ylim(0, 1.05)
#ax.xaxis.set_ticks()
ax.xaxis.set_ticks(bins+10)
ticklabelcolor = 'black'
xticks = ["2048", "8192", "32K", "128K"]
ax.set_xticklabels(xticks, color=ticklabelcolor)

plt.show()

def string(x):
    if x >= (1024 * 1024 * 1024):
        return str(x/(1024*1024*1024)) + 'B'    
    elif x >= (1024 * 1024):
        return str(x/(1024*1024)) + 'M'
    elif x >= 1024:
        return str(x/1024) + 'K'
    else:
        return str(x)

ticklabelcolor = 'black'
logp = np.arange(1,19,1)
p = np.array([2**i for i in logp])
#ax.xaxis.set_ticks(p[1::2])
#xticks =np.array([2**x for x in logp[1::2]])
#xticks = np.array([string(x) for x in xticks])
'''
