#!/usr/bin/env python

import matplotlib.pyplot as plt
import numpy as np

fig, ax = plt.subplots()

N = 5

localsort = [1.259, 1.312, 1.284, 1.33, 1.328]
chist = [1.292, 1.371, 1.393, 1.55, 1.767]
cdata_exchange = [3.8296, 3.866, 3.8748, 4.06, 4.772]
hist = [a_i - b_i for a_i, b_i in zip(chist, localsort)]
data_exchange = [a_i - b_i for a_i, b_i in zip(cdata_exchange, chist)]


localsort_dup = [1.289, 1.31, 1.277, 1.29, 1.329]
chist_dup = [1.32, 1.379, 1.401, 1.56, 1.856]
cdata_exchange_dup = [3.87, 3.87, 3.87, 4.16, 4.96]
hist_dup = [a_i - b_i for a_i, b_i in zip(chist_dup, localsort_dup)]
data_exchange_dup = [a_i - b_i for a_i, b_i in zip(cdata_exchange_dup, chist_dup)]





ind = np.arange(N)    # the x locations for the groups
width = 0.30       # the width of the bars: can also be len(x) sequence
epsilon = 0.05

colors = ['#0e326d', '#01630e', '#444444']
edgecolors = ['#000000', '#444444']

#colors_dup = ['#166bf7', '#04ed23', '#888888']
colors_dup = ['#166bf7', '#ffffff', '#888888']
edgecolors_dup = ['#000000', '#888888']

colors = colors_dup
edgecolors = edgecolors_dup


#edgecolors = ['#a84d05', '#444444']

#color1 = '#e06c0d' #(1.0,0.5,0.62)
#color2 = '#af0505' #'#028413' #(0.2588,0.4433,1.0)
#color3 = '#999999' #'#d62728'


p1 = plt.bar(ind, localsort, width, hatch="//",
		 color=colors[0],align='center', linewidth = 1, edgecolor = edgecolors[0])
p2 = plt.bar(ind, hist, width, bottom=localsort,
		 color=colors[1], align='center', linewidth = 1)
p3 = plt.bar(ind, data_exchange, width, bottom=chist, hatch="\\\\",
		 color=colors[2], align='center', linewidth = 1, edgecolor = edgecolors[1])


p1_dup = plt.bar(ind+width+epsilon, localsort_dup, width, hatch="//",
         color=colors_dup[0],align='center', linewidth = 1, edgecolor = edgecolors[0])
p2_dup = plt.bar(ind+width+epsilon, hist_dup, width, bottom=localsort_dup,
         color=colors_dup[1], align='center', linewidth = 1)
p3_dup = plt.bar(ind+width+epsilon, data_exchange_dup, width, bottom=chist_dup, hatch="\\\\",
         color=colors_dup[2], align='center', linewidth = 1, edgecolor = edgecolors[1])




pcolor = '#0e326d'

#plt.plot(ind, cdata_exchange, '-', color=pcolor,  lw=3.0,  
#	marker='x', mew = 3.0, markersize = 10,
#	markerfacecolor='none', markeredgecolor=pcolor,
#	dash_capstyle='round', label='HSS')

label_fontsize=15
plt.ylabel('Execution time (sec)', fontsize=label_fontsize)
#plt.xlabel('Distribution')
#plt.title('HSS: weak scaling')
plt.xticks(ind+(width+epsilon)/2, ("2048", "4096", "8192", "16K", "32K"))
#plt.yticks(np.arange(0, 81, 10))
plt.ylim(ymin=0, ymax=7)
leg = plt.legend((p3_dup[0], p2_dup[0], p1_dup[0]), ('data exchange', 'histogramming','local sort'), fontsize=label_fontsize)
#leg = plt.legend(bbox_to_anchor=(0.06, 0.9), borderaxespad=0, loc=2, numpoints=3, handlelength=5,prop={'size':12})
leg.get_frame().set_linewidth(0.0)
ax.set_axisbelow(True)
ax.yaxis.grid()
plt.xticks(rotation=45)
plt.tick_params(labelsize=label_fontsize)
plt.savefig("dup_vs_nodup.pdf")
#plt.show()

'''
import numpy as np
import pylab as P
import matplotlib.pyplot as plt
import matplotlib
from matplotlib.ticker import LogLocator

fig, ax = plt.subplots()

#
# The hist() function now has a lot more options
#
#mu, sigma = 200, 25
#x = sigma*P.randn(4,3)


#print x[0], x[1], x[2], x[3], len(x)
counts, bins, patches = plt.hist(x, 4, histtype='bar', stacked=True)
plt.grid(linestyle=':', linewidth=1, color='grey')
#P.ylim(0, 1.05)
#ax.xaxis.set_ticks()
ax.xaxis.set_ticks(bins+10)
ticklabelcolor = 'black'
xticks = ["2048", "8192", "32K", "128K"]
ax.set_xticklabels(xticks, color=ticklabelcolor)

plt.show()

def string(x):
    if x >= (1024 * 1024 * 1024):
        return str(x/(1024*1024*1024)) + 'B'    
    elif x >= (1024 * 1024):
        return str(x/(1024*1024)) + 'M'
    elif x >= 1024:
        return str(x/1024) + 'K'
    else:
        return str(x)

ticklabelcolor = 'black'
logp = np.arange(1,19,1)
p = np.array([2**i for i in logp])
#ax.xaxis.set_ticks(p[1::2])
#xticks =np.array([2**x for x in logp[1::2]])
#xticks = np.array([string(x) for x in xticks])
'''
