import matplotlib.pyplot as plt
import numpy as np
import math

tc =  0.014668e-06
tw = 0.36092036e-9
ts = 5.71e-6

def read_floats(filename):
    with open(filename) as f:
        return [float(x) for x in f]


#plt.figure(1)
logp = np.arange(1,18,1)
logp_base2 = np.array([i * math.log(2) for i in logp])
p = np.array([2**i for i in logp])
p2 = np.array([i*i for i in p])
plogp20 = np.array([x*y*20 for x, y in zip(logp, p)])
plogp20 = np.array([i * math.log(2) for i in plogp20])
plogp_plus_20 = [p[i] * (logp[i] + 20) for i  in range(0, len(logp_base2))]

print(p)
print(logp)
print(p2)
print(plogp20)


#font = {'family': 'sans-serif',
#        'color':  'darkred',
#        'name': 'Gillius',
#        'weight': 'normal',
#        'size': 16,
#        }


#font.set_style('oblique')

#plt.rc('font',**{'family':'sans-serif','sans-serif':['Gillius']})
#plt.rc('font',**{'family':'sans-serif','sans-serif':['Tahoma'], 'size':12})


import matplotlib as mpl

#mpl.rc('font', family='sans-serif')
plt.rc('text', usetex=True) 


fig, ax = plt.subplots()
#with plt.style.context('fivethirtyeight'):
plt.plot(p, p2, '--', color='#000000',  lw=4,   mew = 2, markersize = 8, markerfacecolor="None", markeredgecolor="orange")
plt.plot(p, plogp20, '-', color='#840909', lw=3, mew = 2, markersize = 8, markerfacecolor="None", markeredgecolor="red")


#plt.plot(p, p2, '-b',      mew = 2, markersize = 8, markerfacecolor="None", markeredgecolor="blue", label="quad")
#plt.plot(p, plogp20, '-k', mew = 2, markersize = 8, markerfacecolor="None", label="log")
plt.xlabel('p :  Number of processors', fontsize="x-large")
plt.ylabel('Sample Size : ', fontsize="x-large")


#, label=r'$\textbf{p}^{\textbf{2}}$'
#, label=r'$\textbf{Kplog p}$'


#plt.title('Timings for weak Scaling for Transpose Exchange N/p=32768')
#plt.ylim(ymax = 10)
leg = plt.legend([r'$\textbf{p}^{\textbf{2}}$', r'$\textbf{Kplog p}$'],loc=2, fontsize="x-large", numpoints=20, handlelength=4)
leg.get_frame().set_linewidth(0.0)

#plt.xticks(np.arange(min(logp), max(logp)+1, 1))

#ax.set_axis_bgcolor((0.95, 0.95, 0.95)) 

def string(x):
    if x >= (1024 * 1024):
        return str(x/(1024*1024)) + 'M'
    elif x >= 1024:
        return str(x/1024) + 'K'
    else:
        return str(x)

ax.set_xscale('log', basex=2)

#ax.xaxis.set_ticks(p[0::2])
#xticks =np.array([2**x for x in logp[0::2]])
#xticks = np.array([string(x) for x in xticks])
#ax.set_xticklabels(xticks)


ax.set_yscale('log', basey=2)
logps = np.arange(1,30,4)
#ax.yaxis.set_ticks(np.array([2**x for x in logps]))
yticks = np.array([2**x for x in logps])
yticks = np.array([string(x) for x in yticks])
#ax.set_yticklabels(yticks)
tickcolor = 'grey'
#ax.tick_params(axis='x', colors=axcolor)
#ax.tick_params(axis='y', colors=axcolor)
axcolor = 'grey'
ax.spines['bottom'].set_color(axcolor)
ax.spines['top'].set_color(axcolor) 
ax.spines['right'].set_color(axcolor)
ax.spines['left'].set_color(axcolor)



plt.grid(linestyle=':', linewidth=1)

'''
def f(t):
    return np.exp(-t) * np.cos(2*np.pi*t)

t1 = np.arange(0.0, 5.0, 0.1)
t2 = np.arange(0.0, 5.0, 0.02)

plt.figure(2)
#plt.subplot(211)
plt.plot(t1, f(t1), 'bo', t2, f(t2), 'k')
 
#plt.subplot(212)
#plt.plot(t2, np.cos(2*np.pi*t2), 'r--')
fig.savefig('./samplesize.png')
'''

plt.show()























